using CloudBuilder.Core.Authorization;
using CloudBuilder.Core.DatabaseAccessor.Entity;
using System.ComponentModel.DataAnnotations;
using System.ComponentModel.DataAnnotations.Schema;
namespace CloudBuilder.AI.Entity
 {
    [TypeScript]
    [Table("ai_book_person")]
    public class AiBookPersonEntity : EntityBase<string>
    {

    public AiBookPersonEntity() 
    {
    }

    [Column("created_datetime")]
    public DateTime CreatedDatetime  { get; set; }
    [Column("created_by")]
    public string CreatedBy  { get; set; }
    [Column("updated_datetime")]
    public DateTime UpdatedDatetime  { get; set; }
    [Column("updated_by")]
    public string UpdatedBy  { get; set; }
    [Key]
    [Column("guid")]
    public string Guid  { get; set; }
    [Column("book_guid")]
    public string BookGuid  { get; set; }
    [Column("person_name")]
    public string PersonName  { get; set; }
    [Column("actor_name")]
    public string? ActorName  { get; set; }
    [Column("gender")]
    public string? Gender  { get; set; }
    [Column("sentiment")]
    public string? Sentiment  { get; set; }
    [Column("sound_file_path")]
    public string? SoundFilePath  { get; set; }
    [Column("status")]
    public string? Status  { get; set; }

    public const string CREATED_DATETIME = "CreatedDatetime";
    public const string CREATED_BY = "CreatedBy";
    public const string UPDATED_DATETIME = "UpdatedDatetime";
    public const string UPDATED_BY = "UpdatedBy";
    public const string GUID = "Guid";
    public const string BOOK_GUID = "BookGuid";
    public const string PERSON_NAME = "PersonName";
    public const string ACTOR_NAME = "ActorName";
    public const string GENDER = "Gender";
    public const string SENTIMENT = "Sentiment";
    public const string SOUND_FILE_PATH = "SoundFilePath";
    public const string STATUS = "Status";

    public const string DB_NAME_AI_BOOK_PERSON = "ai_book_person";
    public const string DB_NAME_FIELDS="created_datetime,created_by,updated_datetime,updated_by,guid,book_guid,person_name,actor_name,gender,sentiment,sound_file_path,status";

    public const string DB_CREATED_DATETIME = "created_datetime";
    public const string DB_CREATED_BY = "created_by";
    public const string DB_UPDATED_DATETIME = "updated_datetime";
    public const string DB_UPDATED_BY = "updated_by";
    public const string DB_GUID = "guid";
    public const string DB_BOOK_GUID = "book_guid";
    public const string DB_PERSON_NAME = "person_name";
    public const string DB_ACTOR_NAME = "actor_name";
    public const string DB_GENDER = "gender";
    public const string DB_SENTIMENT = "sentiment";
    public const string DB_SOUND_FILE_PATH = "sound_file_path";
    public const string DB_STATUS = "status";


    public static AiBookPersonEntity GetInstance()
    {
        return new AiBookPersonEntity();
    }

    public virtual void CopyFrom(AiBookPersonEntity source)
    {
        CopyFrom(source, true);
    }

    public virtual void CopyFrom(AiBookPersonEntity source, bool includeSystemFields)
    {
        if (source == null)
        {
            throw new NullReferenceException("Source entity is null.");
        }

        this.CreatedDatetime =  source.CreatedDatetime;
        this.CreatedBy =  source.CreatedBy;
        this.UpdatedDatetime =  source.UpdatedDatetime;
        this.UpdatedBy =  source.UpdatedBy;
        this.Guid =  source.Guid;
        this.BookGuid =  source.BookGuid;
        this.PersonName =  source.PersonName;
        this.ActorName =  source.ActorName;
        this.Gender =  source.Gender;
        this.Sentiment =  source.Sentiment;
        this.SoundFilePath =  source.SoundFilePath;
        this.Status =  source.Status;

        if (includeSystemFields)
        {
        this.CreatedDatetime =  source.CreatedDatetime;
        this.CreatedBy =  source.CreatedBy;
        this.UpdatedDatetime =  source.UpdatedDatetime;
        this.UpdatedBy =  source.UpdatedBy;
        }
    }

    public override string GetSelectFrom()
    {
        return $" select {DB_NAME_FIELDS} from { DB_NAME_AI_BOOK_PERSON}  with(nolock) ";
    }
	
    public override string GetSelectCountFrom(string sqlWhere)
    {
        return $" select count(*) from { DB_NAME_AI_BOOK_PERSON}  with(nolock) where 1=1 {sqlWhere}";
    }
	
    public override string GetSelectTopFrom(int limit, int start,string orderby,string orderbytag,  string sqlWhere)
    {
            if (string.IsNullOrEmpty(orderbytag)  || orderbytag.Trim() != "desc") orderbytag = "asc";
            if (string.IsNullOrEmpty(orderby) || !DB_NAME_FIELDS.Contains(orderby)) orderby =  DB_GUID ;  		
		string top = limit > 0 ? $"top {limit}" : "";
        return $" select {top} {DB_NAME_FIELDS} from (select {DB_NAME_FIELDS}  ,row_number() over(order by {orderby} {orderbytag}) as num from { DB_NAME_AI_BOOK_PERSON}  with(nolock) where 1=1 {sqlWhere} ) a where num> {limit * (start - 1)}";
    }

    public AiBookPersonEntity Clone()
    {
        AiBookPersonEntity result = new AiBookPersonEntity();
        result.CopyFrom(this);

        return result;
    }

    }
}
